VERSION 5.00
Object = "{3B7C8863-D78F-101B-B9B5-04021C009402}#1.2#0"; "RICHTX32.OCX"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   4785
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   4785
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   WindowState     =   2  'Maximized
   Begin RichTextLib.RichTextBox RichTextBox1 
      Height          =   3765
      Left            =   2880
      TabIndex        =   4
      Top             =   1200
      Width           =   4365
      _ExtentX        =   7699
      _ExtentY        =   6641
      _Version        =   393217
      TextRTF         =   $"frmCurPosition.frx":0000
   End
   Begin VB.Label Label4 
      Height          =   705
      Left            =   30
      TabIndex        =   3
      Top             =   4260
      Width           =   2325
   End
   Begin VB.Label Label3 
      Height          =   615
      Left            =   30
      TabIndex        =   2
      Top             =   3270
      Width           =   2295
   End
   Begin VB.Label Label2 
      Height          =   645
      Left            =   60
      TabIndex        =   1
      Top             =   2220
      Width           =   2235
   End
   Begin VB.Label Label1 
      Height          =   555
      Left            =   60
      TabIndex        =   0
      Top             =   1200
      Width           =   2205
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'*************************************************************************'
'made by Sachin Judge.
'
'Alongwith the functions it is supposed to perform, the code also takes care of <ENTER> which takes up 2 characters.
'When deleting, 2 is subtracted from the total whenever <ENTER> is deleted.
'*************************************************************************'

Option Explicit
Dim total As Integer
Dim keyVal As Integer
Dim curLineNo As Integer
Dim curPos As Integer
Dim totLines As Integer
Dim entKey() As Integer

Private Sub Form_Load()
    totLines = 1
    ReDim entKey(0) As Integer
    entKey(0) = 0
End Sub

Private Sub RichTextBox1_Change()
    Dim i As Integer
    
    curPos = RichTextBox1.SelStart
    
    If keyVal <> 8 And keyVal <> 46 And keyVal <> 13 Then
        total = total + 1
    Else
        If keyVal = 8 Or keyVal = 46 Then
            Dim check As Boolean
            check = False
            'check whether the character being deleted is <ENTER> or not
            For i = 1 To UBound(entKey())
                If curPos = entKey(i) - 2 Then   'check the position
                    total = total - 2  'delete 2 from the total, since <ENTER> consists of 2 characters
                    check = True
                End If
            Next
            
            If check = False Then   'if the character being deleted is not <ENTER>
                total = total - 1
            End If
            
        Else
            total = total + 2   'if <ENTER is pressed>
            Dim ubnd As Integer
            ubnd = UBound(entKey()) + 1
            ReDim Preserve entKey(ubnd) As Integer
            entKey(ubnd) = curPos   'add the position in the array at which <ENTER> is pressed
        End If
    End If
    
    curLineNo = RichTextBox1.GetLineFromChar(curPos) + 1
    
    If totLines < curLineNo Then    'to increment totalLines whenever a new line comes into picture
        totLines = curLineNo
    End If
    
    'the following helps in case a complete line is deleted
    If totLines > (RichTextBox1.GetLineFromChar(total) + 1) Then
        totLines = totLines - 1
    End If
    
    Label1.Caption = "total chars: " & total
    Label2.Caption = "cursor position : " & curPos
    Label3.Caption = "Current Line : " & curLineNo
    Label4.Caption = "Total lines : " & totLines
End Sub

Private Sub RichTextBox1_KeyDown(KeyCode As Integer, Shift As Integer)
    keyVal = KeyCode
End Sub
